

/**
 * Simple String Class for use with 8Bit AVR RISC Controllers
 * @author Andi Dittrich <dit@bimaq.de>
 * @version 1.0
 * @license NEW BSD LICENSE
 */
#include "String.h"


/**
 * KONSTRUKTOR
 */
String::String(){}

/**
 * assign value by constructor
 */
String::String(char* s){
	this->s = s;
	this->countLength();
};

/**
 * INTERN
 * count length of \0 terminated string
 */
void String::countLength(){
	// temp pointer
	char *t = this->s;

	// set default length
	this->sLength = 0;

	// count
	while (*(t++) != '\0'){
		this->sLength++;
	}
}

/**
 * direct assign values to string
 */
String String::operator= (char* s) {
	this->s = s;
	this->countLength();
	return *this;
};


/**
 * get single char of string (NOT SAFE)
 * @return char single character
 */
char String::getChar(int index){
	return (char) *(this->s+index);
};

/**
 * get string length
 * @return int string length in bytes
 */
int String::length(){
	return this->sLength;
}
