#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <inttypes.h>
#include <stdio.h>

#include "bimaq/String.h"
#include "bimaq/io/USART.h"

//using namespace std;

/** C++ **************************************************/
#if defined (__cplusplus)
	extern "C" {
#endif
/** C++ **************************************************/


		USART::USART (int chan){
			unsigned int ubbr = 103;

			if (chan==0){

					DDRE = 0xFF;
					PORTE = 0;
					DDRE = 0;
					DDRE  |= (1<<DDE1)|(1<<DDE2);

					UBRR0H = (ubbr>>8);
					UBRR0L = ubbr;
					//UBRR0H = (uint8_t) ((F_CPU/(baudrate*16)-1)>>8);
					//UBRR0L = (uint8_t)  (F_CPU/(baudrate*16)-1);

					// enable receiver and transmitter
					UCSR0B = (1<<RXEN0)|(1<<TXEN0);
					// 1 stop bit
					UCSR0C = (0<<USBS0);
					// 8Bit Data
					UCSR0C |= (1<<UCSZ01)|(1<<UCSZ00)|(0<<UCSZ02);
					// Parity Disabled
					UCSR0C |= (0<<UPM01)|(0<<UPM00);
			};

			if (chan==1){

//				UBRR1H = (103>>8);
//				UBRR1L = 103;

				//UBRR0H = (uint8_t) ((F_CPU/(baudrate*16)-1)>>8);
				//UBRR0L = (uint8_t)  (F_CPU/(baudrate*16)-1);

				// enable receiver and transmitter
				UCSR1B = (1<<RXEN0)|(1<<TXEN0);
				// 1 stop bit
				//UCSR1C = (0<<USBS1);
				// 8Bit Data
				//UCSR1C |= (1<<UCSZ11)|(1<<UCSZ10)|(0<<UCSZ12);
				// Parity Disabled
				//UCSR1C |= (0<<UPM11)|(0<<UPM10);


			};


		};
		int USART::getChannel(){
			return this->channel;
		};
		void USART::write(unsigned char data){
			while ( !( UCSR0A & (1<<UDRE0)) )
			;
			UDR0 = data;
		};




		/**
		 * KONSTRUKTOR
		 */
		String::String(){}

		/**
		 * assign value by constructor
		 */
		String::String(char* s){
			this->s = s;
			this->countLength();
		};

		/**
		 * INTERN
		 * count length of \0 terminated string
		 */
		void String::countLength(){
			// temp pointer
			char *t = this->s;

			// set default length
			this->sLength = 0;

			// count
			while (*(t++) != '\0'){
				this->sLength++;
			}
		}

		/**
		 * direct assign values to string
		 */
		String String::operator= (char* s) {
			this->s = s;
			this->countLength();
			return *this;
		};


		/**
		 * get single char of string (NOT SAFE)
		 * @return char single character
		 */
		char String::getChar(int index){
			return (char) *(this->s+index);
		};

		/**
		 * get string length
		 * @return int string length in bytes
		 */
		int String::length(){
			return this->sLength;
		}






/**
 * MAIN
 */
int main(void){
	   DDRB=0xFF;

	   String test;
	   test ="HelloWorld";

	   USART chan0 (0);

	   for (int i=0;i<test.length();i++){
		   chan0.write(test.getChar(i));
	   }

	   chan0.write(test.getChar(0));
	   chan0.write(test.getChar(1));
	   chan0.write(test.getChar(2));
	   chan0.write(test.length()+97);
	   chan0.write(test.getChar(1));
	   chan0.write(test.getChar(2));

	   for(;;){
	      PORTB=0xFF;
	      chan0.write('.');
	      _delay_ms(100);
	      PORTB=0x00;
	      _delay_ms(100);
	   }
};


/** C++ **************************************************/
#if defined (__cplusplus)
};
#endif
/** C++ **************************************************/



